//
//  SCAdSessionController.h
//  SmartclipSDKiOS
//
//  Copyright © 2018 smartclip. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <WebKit/WebKit.h>
#import "SCAdFacadeDelegate.h"
#import "SCAdSessionStateListener.h"

NS_ASSUME_NONNULL_BEGIN

@class SCAdSlotController;
/**
 * The SCAdSessionController is a configuration for the SpotX advertising SDK,
 * it is the initial component that establishes the basic connection to the
 * Ad server and creates the SCAdSlotController instances.
 */
@interface SCAdSessionController : NSObject <WKScriptMessageHandler, WKUIDelegate, WKNavigationDelegate>
@property (nonatomic, weak) id<SCAdSessionStateListener> sessionStateListener;

/// CompletionBlock that delivers an array
typedef void (^SCSetCompletionBlock)(NSSet* _Nullable set);

/// Use this function to get your SCAdSlotController, the object that handles an adSlot
- (SCAdSlotController*)createAdSlotWithListener:(id<SCAdFacadeDelegate>)listener;

/// Stop and adSlot
- (void)stopAdSlot;

/// Skip an ad
- (void)skipAd;

/// Cleanup after usage!
- (void)cleanup;

/// Delete all cookies
- (void)deleteCookies;

/// Get a list of saved cookies
- (void)getSavedCookiesWithCompletion:(SCSetCompletionBlock)completion;

+ (void)setUserTracking:(Boolean)allowed;
@end

NS_ASSUME_NONNULL_END
